summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2004-05-08 12:47:23 +0000
committerJim Meyering <jim@meyering.net>2004-05-08 12:47:23 +0000
commit198dc407d36fc14325d34d533939653719c64be6 (patch)
tree00c9690916979f0869a017f2c0de90dda2d4b2bb /tests
parent0ce65fc2059e379747418c7064ede2ce2ae04f32 (diff)
downloadcoreutils-198dc407d36fc14325d34d533939653719c64be6.tar.xz
New file; check for the above fix.
Diffstat (limited to 'tests')
-rwxr-xr-xtests/rm/no-give-up41
1 files changed, 41 insertions, 0 deletions
diff --git a/tests/rm/no-give-up b/tests/rm/no-give-up
new file mode 100755
index 000000000..df26acb14
--- /dev/null
+++ b/tests/rm/no-give-up
@@ -0,0 +1,41 @@
+#!/bin/sh
+# With rm from coreutils-5.2.1 and earlier, `rm -r' would mistakenly
+# give up too early under some conditions.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+PRIV_CHECK_ARG=require-root . $srcdir/../priv-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir d
+touch d/f
+chown -R $NON_ROOT_USERNAME d
+chmod u=rwx .
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# This must fail, since `.' is not writable by $NON_ROOT_USERNAME.
+setuidgid $NON_ROOT_USERNAME env PATH=$PATH rm -rf d 2>/dev/null && fail=1
+
+# d must remain.
+test -d d || fail=1
+
+# f must have been removed.
+test -f d/f && fail=1
+
+(exit $fail); exit $fail